
  //http://paulfjujo.free.fr/_18F27K42_47K42/BASE_18F27K42_Frequencemetre_SMT1_2021.htm#SMT1%20compteur

#define Version "2022_0825"
// SMT1 pour mesure de duree
 /*

P18F27K42_Fosc_Interne_IVT_interrupts_16x4_PLL_64MHz.cfgsch
CONFIG1L : $300000 : 0x0024
CONFIG1H : $300001 : 0x0029
CONFIG2L : $300002 : 0x002D
CONFIG2H : $300003 : 0x00A7
CONFIG3L : $300004 : 0x000B
CONFIG3H : $300005 : 0x003F
CONFIG4L : $300006 : 0x009F
CONFIG4H : $300007 : 0x000F
CONFIG5L : $300008 : 0x0001
CONFIG5H : $300009 : 0x0000
*/


 // datasheet 807 pages




 // Hardware
 /*
 Pin 28  RB7  --x  x----ICSP Data
 Pin 27  RB6  --x  x-----ICSP Clock
 Pin 26  RB5   --->  DOut  simili SPI ->cde  Anneau 60 Leds RGW WS812
 Pin 25  RB4   --> SQA pour synchro Analyser
 Pin 24  RB3
 Pin 23  RB2  <------ input  pour affichage Pretest 0 à 9
 Pin 22  RB1  <------ input pour forcage init RTC
 Pin 21  RB0  <-----  input : recoit signal 1HZ de la RTC DS3231
 Pin 20      VDD --------+5V
 Pin 19      Vss ---------Gnd          fil noir cable prolific
 Pin 18  RC7  RX UART  <-- Keyboard    fil Vert cable prolific
 Pin 17  RC6  TX UART  --> Display     fil Blanc cable prolific
 Pin 16  RC5

 Pin 15  RC4  SDA  I2C
 Pin 14  RC3  SCL  I2C

 Pin 13  RC2  ---> SPI Clock -> Matrice
 Pin 12  RC1  ---> SPI Dout -> Matrice
 Pin 11  RC0  -->  CS          MAtrice MAX7219
 
 Pin 10  RA6   x   option 22pF   Q 32Mhz
 Pin  9  RA7   x   option  22pF   Q 32Mhz
 Pin  8  VSS ---------  Gnd
 Pin  7  RA5
 Pin  6  RA4  -----> led  Rouge
 Pin  5  RA3
 Pin  4  RA2
 Pin  3  RA1
 Pin  2  RA0   <---- OWS input pour DS18B20
 Pin  1  RE3 MCLR  Reset <--------ICSP PGRM    avec pull up 10K
                          |----x  x----/0V   cavalier RESET
 */
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_18F27K42_Tests_SMT1_chronometre_2022_08"
#define Project "18F27K42_Tests_SMT1_chronometre_2022_08.mcppi"
#define Source  "PIC18F27K42_test_SMT1_Chronometre_UART_IVT_"
#define Annexe " "
#define Eeprom " "
#define Config " P18F27K42_Fosc_Interne_IVT_interrupts_16x4_PLL_64MHz.cfgsch "

#define PROCESSOR "18F27K42"
#define POWER_SUPPLY  " 5V"
#define OSCILLATEUR_INTERNE
#define FOSC "64.0"  // MHz
#define BAUD 19200  // UART1

#define CLS 12
#define CR 13    //0x0D
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7
#define Separator 0x20   // space
#define ON 0    // because led tirée au +VCC
#define OFF 1
#define SPECIAL 1
#define NORMAL 0

#ifndef Byte
#define Byte unsigned char
#endif

#ifndef Word
#define Word unsigned int
#endif

#define With_UART
//#define With_RTC_DS3231
//#define DS3231_ADDR 0xD0     // I2C Hardware : sur 7 bits  RTC DS3231
 // I2C SDA sur RC4
 // I2C SCL sur RC3


#define Print UART1_Write_Text
#define CPrint UART1_Write_CText
//#define OWS_Pin_Sensor1  &PORTA,0     // sensor DS18B20 #1 OWS

const code char mesg0[]=" Directory :"Directory"\r\n";
const code char mesg1[]=" MikroC pro 7.60\r\n";
const code char mesg2[]=" Projet :"Project"\r\n";
const code char mesg3[]=" Test PIC18F27K42 IVT et compteur 24 bits SMT1 en chronometre \r\n";
const char char mesg4[]=" Config bit : "Config" FOSC:"FOSC" MHz\r\n";
const char char mesg5[]=" Source : "Source"_"Version".c\r\n";

const char char mesg6[]=" ";
const char char mesg7[]="  \r\n";
const char char mesg8[]=" ";
const char char mesg9[]=" ";
const char char mesg10[]=" ";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9,mesg10};
const char Blancs[]="  ";


sbit SQA           at LATA.B3;      // -> synchro Analyser SQA
sbit SQA_Dir       at TRISA.B3;
sbit RTC_Forcee_Dir at TRISB.B1 ;
sbit RTC_Forcee     at PORTB.B1;

sbit LED_Jaune at LATA.B2;
sbit LED_Jaune_Dir at TRISA.B2;
sbit LED_Verte at LATA.B5;
sbit LED_Verte_Dir at TRISA.B5;
sbit LED_Rouge at LATA.B4;
sbit LED_Rouge_Dir at TRISA.B4;
sbit CTS at LATC.B5;
sbit CTS_Dir at TRISC.B5;


#define MAX_LEN_BUFFER1 128
#define MAX_LEN_CRAM1 80
#define MAX_LEN_TEXTE  128

//unsigned char LATCx absolute 0x0F8B;   // 18F26K222
//unsigned char LATCx absolute 0x3FCC;    //18F27K42  see Table 412.1 page 717

unsigned int i,j,k,l,m,n;
int j2;
unsigned int Kx=0;
volatile unsigned char Temp=0;
volatile unsigned char Buffer1[MAX_LEN_BUFFER1];
unsigned char CRam1[MAX_LEN_CRAM1];
unsigned char TEXTE [MAX_LEN_TEXTE];
unsigned char *txt;
volatile int Flag_Buffer1;
volatile unsigned char c0,c1,cx;
volatile unsigned int i1;
volatile unsigned int Index1;
volatile unsigned int CptErr;

volatile unsigned int Cpt1;
unsigned long  val1;
unsigned long val2;
unsigned long val3;

float F1,F2;

unsigned char * p1;
unsigned char * p2;

unsigned int Count0 = 0;
unsigned char Etat_clock=0;
unsigned int clk;

signed char Dummy;

volatile int Flag_Timer0=0;
volatile int Flag_Timer1=0;

unsigned long  SMT1_Measure;
unsigned char *ST;

void Init_Hardware(void) ;
void CRLF1(void) ;
void Raz_Buffer1(char avecIT) ;
void UART1_Write_CText(const char *txt);
void strConstRamCpy(unsigned char *dest, const code char *source);
void Decompile_byte(unsigned char un)  ;
void Init_SMT1(void);
void Arme_Timer1(int  Max_Timer1) ;
void Init_Timer1(void);
void Init_Timer0(void);
void Wait_Keyb(int T) ;
 void Float2Ascii (float x, unsigned char *str,char precision) ;


void Interrupt_UART1() iv IVT_U1RX ics ICS_AUTO

{
     // Reception terminal UART
     //RX UART IT
     if (( U1RXIF_bit==1) && ( U1RXIE_bit==1))
     {

     // c1 =UART1_Read();
     c1=U1RXB;
      //c1= UART1_Remappable_Read();
      // echo
      //  U1TXB=c1;
      if (U1ABDOVF_bit==1)    // voir parag  31.2.2.4   page 479
      {
       U1ABDOVF_bit = 0 ;
       CptErr++;
       c1=U1RXB ;
       }
       if(U1FERIF_bit==1 )
       {
        CptErr++;
        c1 = UART1_Read();
       }
      // lecture d'un bloc de 64 cars
       if  (i1>62)
     //  if ((c1==CR) || (Index1>MAX_LEN_BUFFER1-1))
       {
        //U1TXB=XOFF;
        //Flow_OFF
        U1RXIE_bit=0;
        Flag_Buffer1=1;
        Buffer1[i1]=0;
       // Index1=i1;
        //i1=0;
        TMR1IE_bit=0;
       }
       else
       {
       Flag_Buffer1=0;
       Buffer1[i1]=c1;
       Index1++;
       i1++;
       }
     }
}

   
 void Interrupt_Timer1() iv IVT_TMR1 ics ICS_AUTO
 {
 
      // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1--;

     if (Cpt1 <1)   // x100 ms  @16MHz
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Flag_Timer1=1;
      }
     TMR1H         = 0x3C;
     TMR1L         = 0xB0;
     TMR1IF_bit=0;
   }
}



#include "built_in.h"     // for  Hi  Lo ..etc


void Decompile_Byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
       UART1_Write('*');
     //  UART1_Write(49u);  //  '1'
    else
       UART1_Write(' ');
      // UART1_Write(48u);  //  '0'
    masque =masque >>1;
  }
}

void Arme_Timer1(int  Max_Timer1)
{
   // 100mS * Max_Timer1
  T1CON         = 0x31;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  Cpt1=  Max_Timer1;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IF_bit  = 0;
  TMR1IE_bit= 1;
  }



void Init_Timer1(void)
 {
// FOSC=64MHz    25ms
//Timer1
//Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 25 ms
  T1CKPS1_bit=1;
  T1CKPS0_bit=1;
  T1CON.B0=1;
  T1RD16_bit=1;
  T1CON         = 0x32;
  T1GCON=0;  //GE disabled
  T1CLK=1; //  FOSC/4
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
   TMR1IF_bit  = 0;
  TMR1IP_bit=1;   // high level interrupt
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}

void Wait_100mS(){  Delay_ms(100);}
void   Wait_250uS(void){ Delay_us(250); }

// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR); UART1_Write(LF);
}

void UART1_Write_CText(const char *txtR)
 {
   while (*txtR)
      UART1_Write(*txtR++);
 }

void Raz_Buffer1(char avecIT)
{     //  Flow_OFF
        for(i1=0;i1<64;i1++) Buffer1[i1]=0;
     //   for(i1=0;i1<MAX_LEN_BUFFER1-1;i1++) Buffer1[i1]=0;
        i1=0;
        p1=0;
       // Index1=0;
        Flag_Buffer1 =0 ;
        c1=0;
        U1RXEN_bit=1;
         U1ERRIR = 0x00;
         U1ERRIE = 0x00;
      if (avecIT==1)   U1RXIE_bit=1;  else    U1RXIE_bit=0;
      //  Flow_ON
}

void Init_Hardware()
{
  PORTA = 0x00;
  ANSELA=0x02;
  TRISA = 0b10000011 ;   // RA0= OWS input  RA1=Analog Input  R2..RA6 as output  RA7 input
  LED_Jaune_Dir=0; // at TRISA.B2;
  LED_Verte_Dir=0; // at TRISA.B3;
  LED_Rouge_Dir=0; //at TRISA.B4;
  LED_Verte=1; // eteinte car Pull UP
  LED_Rouge=1;
  LED_Jaune=1;

  
  ANSELB=0;
  PORTB = 0x00;
  TRISB = 0xFF;    //  RB0..B7 Input   ATTENTION B7 B6 for ICSP Pickit3
  WPUB=0xFF;
  RTC_Forcee_Dir=1;
  SQA_Dir=0;  //     at TRISB4_bit;
  SQA=0;      //      at LATB.B4;


  CM1CON0=0;
  CM2CON0=0;

  PORTC=0xFF;
  TRISC = 0b10000000;    //
  ANSELC=0 ;
  Unlock_IOLOCK();
  RC6PPS = 0x13;   //RC6->UART1:TX1;
  RC5PPS=0;
 // U1CTSPPS = 0x15;   //RC5->UART1:CTS1;
  U1RXPPS = 0x17;   //RC7->UART1:RX1;
  Lock_IOLOCK();
  CTS_Dir=0;
  //Flow_OFF
  //WPUC2_bit=0;
  //ODCC1_bit=0;
  //ODCC5_bit=1;
  WPUC5_bit=1;  // pull Up
  WPUC0_bit=1;  // pull Up
  WPUC1_bit=1;  // pull Up
  WPUC2_bit=1;  // pull Up
  //   Open-Drain Configuration on Pins Rx<7:0>
  //1 = Output drives only low-going signals (sink current only)
  //0 = Output drives both high-going and low-going signals (source and sink current)
  // The user must configure these pins as open-drain inputs.
 //ODCONC.B7=0;
  //ODCONC.B6=0;
  ODCONC.B5=0;
  ODCONC.B2=0;
  ODCONC.B1=0;
  ODCONC.B0=0;

 //FVRCON=0;
 //FVRCON.FVREN=0;  // page 597  paragraph 34.3
 //FVRCON.ADFVR1=1; // 01 = Fixed Voltage Reference Peripheral output is 1,024)
 //FVRCON.ADFVR0=0;
}

void Init_Timer0()
{
// FOS=64MHz  , FOSC/4=16Mhz
//  Timer0
// pour 25mS
//FOSC=64MHz Prescaler 1:32; TMR0 Preload = 15536; Actual Interrupt Time : 100 ms
//  REGISTER 22-1: T0CON0: TIMER0 CONTROL REGISTER 0
   T0CON0=0;
   T0CON0.B7=1;  //   Enable module and operating
   T0CON0.B4=1;  //MD16=1;
//   OUTPS<3:0>: TMR0 Output Postscaler (Divider) Select bits  0111= 1/8    1111=1/16   0000=1/1
   T0CON0.B3=0;
   T0CON0.B2=0;
   T0CON0.B1=0;
   T0CON0.B0=0;
//   REGISTER 22-2: T0CON1: TIMER0 CONTROL REGISTER 1
//   bit 7-5 CS<2:0>:Timer0 Clock Source Select bits = 011 HFINTOSC    010=FOSC/4
   T0CON1.B7=0;  //T0CON1.CS2 !!!!
   T0CON1.B6=1;  //T0CON1.CS1
   T0CON1.B5=0; //T0CON1.CS0
//   bit 4 ASYNC: TMR0 Input Asynchronization Enable bit
//   T0CON1.ASYNC=0;    //The input to the TMR0 counter is synchronized to FOSC/4
    T0CON1.ASYNC=1;    //The input to the TMR0 counter is synchronized to FOSC/4
//   bit 3-0 CKPS<3:0>: Prescaler Rate Select bit     1/32
   T0CON1.B3=0;   // CKPS3:0   0011=> 1/8     0101=> 1/32
   T0CON1.B2=1 ;
   T0CON1.B1=0 ;
   T0CON1.B0=1 ;
 // pour 100mS
  TMR0H         = 0x3C; //15536;
  TMR0L         = 0xB0;
//pour 1000mS
//   TMR0H         =0x0B ;      // 3036
//   TMR0L         =0xDC ;
//   T0CON1.B3=0;   //  0110=> 1/64
//   T0CON1.B2=1 ;
//   T0CON1.B1=1 ;
//   T0CON1.B0=0 ;
   PIR3.TMR0IF = 0;
   PIE3.TMR0IE = 1 ;      // TMR0 Enable Interrupt.
   T0CON0.B7=1;  //   Enable module and operating
   Flag_Timer0=0  ;
   Count0=0;
}

 void Float2Ascii (float x, unsigned char *str,char precision)
{
 // converts a floating point number to an ascii string
 // version limitée à 6 decimales maximum
 // x is stored into str, which should be at least 30 chars long
 int ie, i, k, ndig;
 double y;
  ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 // if x negative, write minus and reverse
 if ( x < 0.0000)
 {
   *str++ = '-';
   x = -x;
 }
 // put x in range 1 <= x < 10
 if (x > 0.00000) while (x < 1.00000)
 {
   x *= 10.000;                // a la place de =*
   ie--;
 }
 while (x >= 10.000)
 {
   x = x/10.000;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.000;
 x += y/2.000;
 if (x >= 10.000) {x = 1.000; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.000;
  }
 *str = '\0';
}



 void Wait_Keyb(int T)
  {
    Raz_Buffer1(1) ;
    Arme_Timer1(T);
    UART1_Write_CText(" ... Waiting Keyboard Touch for <");
    IntToStr(T,CRam1);
    Ltrim(CRam1);     UART1_Write_Text(CRam1);
    UART1_Write_CText(" x 25mS >\r\n");
    while ( (Flag_Buffer1==0) && (Flag_Timer1==0));
    Flag_Timer1=0;
    Raz_Buffer1(0) ;
    CRLF1();
 }
 
 void Init_SMT1(void)
 {
 CPrint(" Test SMT compteur 24 bits (rsum des registres en page 364) \r\n");
    //TABLE 25-3: SUMMARY OF REGISTERS ASSOCIATED WITH SMT1 page 405
   //CPrint(" Affectation (PPS) PIN  SMT1WINPPS RC0  Signal SMT1SIGPPS RC1  \r\n");
    //SMT1 Window SMT1WINPPS RC0
    //SMT1 Signal SMT1SIGPPS RC1
     // Unlock_IOLOCK() ;
    //SMT1WINPPS=RC0;
    //SMT1SIGPPS=RC1;
    //  Lock_IOLOCK()  ;

    // REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER
    //     000=FOSC/4    001=FOSC  010=HINTOSC
      SMT1CLK.CSEL2= 0;
      SMT1CLK.CSEL1= 0;
      SMT1CLK.CSEL0= 1;

    //  REGISTER 25-5: SMT1WIN: SMT1 WINDOW INPUT SELECT REGISTER
    // bit de commande fenetre WINDOW
    //bit 4-0 WSEL<4:0>: SMT1 Window Selection bits
    //  SMT1WIN=0b1000;  // TMR6        timer sur 1 sec
    // SMT1WIN=0b0000;  // SMT1WINPPS  signal 1 HZ RTC DS3231 ?

    // Signal d'entree  mesurer ..pendant l'ouverture Window
    //REGISTER 25-6: SMT1SIG: SMT1 SIGNAL INPUT SELECT REGISTER   page 400
    //  SMT1SIG=0b00000;  //SMTxSIGPPS

    // REGISTER 25-7: SMT1TMRL: SMT TIMER REGISTER  LOW BYTE
     SMT1TMRL=0;
     SMT1TMRH=0;
     SMT1TMRU=0;

     //REGISTER 25-10: SMT1CPRL: SMT CAPTURED PERIOD REGISTER  LOW BYTE
     SMT1CPRL=0;
     SMT1CPRH=0;
     SMT1CPRU=0;

      // registre  SMT1CON0
     SMT1CON0.WPOL=0; // Window Polarity
     SMT1CON0.SPOL=0; // Signal Polarity
     SMT1CON0.CPOL=0; // Clock Polarity
     SMT1CON0.SMT1PS1=0; // PS<1:0>: SMT Prescale Select bits
     SMT1CON0.SMT1PS0=0; // 11=1/8  10=1/4  01=1/2 00=1/1
     SMT1CON0.SMT1EN =1;  // SMT enabled
     SMT1CON0.SMT1STP=0; // 0 =reset 1=STOP;

     SMT1CON1.SMT1GO=0;      // 1= suit l'entre   0=stop suivi
     SMT1CON1.SMT1REPEAT=0; // 0= Single  Acquisition   1=repeat mode



     // REGISTER 25-3: SMT1STAT: SMT STATUS REGISTER
     //WS: SMT1WIN Value Status bit
     // 1 =SMT window is open  ,  0= SMT window is closed
     // AS: SMT_signal Value Status bit ,
     // 1= SMT acquisition is in progress  , 0=SMT acquisition is not in progress

     // 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
      PIR1.SMT1PRAIF=0;
      PIE1.SMT1PRAIE=0;
     //  25.7.2  PERIOD MATCHI NTERRUPT
      PIR1.SMT1IF=0;
      PIE1.SMT1IE=0;


    // unisgned long
      SMT1PRU=0xFF;
      SMT1PRH=0xFF;
      SMT1PRL=0xFF;


       // MODE de fonctionnement
     // modes  page 396   Windowed measure
     //   0000=Timer   0100=windowed measure  1000=counter
     SMT1CON1.B3=0;
     SMT1CON1.B2=0;
     SMT1CON1.B1=0;
     SMT1CON1.B0=0;
     SMT1CON1.SMT1REPEAT=0;
   
     ST=&SMT1_Measure;   // pointeur Byte sur debut entier long 32 bits
    // for test  only
    // SMT1_Measure=32767;
    //CPrint(" SMT1_Measure=32767 => 0x00");
    //ByteToHex(*(ST+2),CRam1); Print(CRam1);
    //ByteToHex(*(ST+1),CRam1); Print(CRam1);
    //ByteToHex(*(ST),CRam1); Print(CRam1);
    //CRLF1();
    // resultat :    SMT1_Measure=32767 => 0x00007FFF

    SMT1_Measure=0;
   }

   
void main()
 {
    OSCCON1 = 0x60;
    OSCFRQ = 0x08;        // FOSC = 64MHz
    Etat_clock=OSCSTAT;
    clk = Clock_kHz()/1000;
    F1=0.0;

   // 8 * 0.0625 nop -> 0.5S
   /*
     _asm NOP
      _asm NOP
       _asm NOP
        _asm NOP
         _asm NOP
          _asm NOP
           _asm NOP
             _asm NOP

   */
    Init_Hardware();
    Delay_ms(500);
  
  LED_Rouge=0;
  for (i=0;i<MAX_LEN_TEXTE-1;i++) TEXTE[i]=0;
  txt=&TEXTE[0];

    //UART1_Init(19200);
    UART1_Remappable_Init(19200);

   // Flow_OFF
    Delay_ms(2000);
   // Flow_ON
    SWDTEN_bit=0;
    CRLF1();
    txt=&TEXTE[0];
    UART1_Write_CText("\r\n Presentation : \r\n");
    for (i=0;i<6;i++)   UART1_Write_CText(Messages[i]);
    
     //sprintf(txt," Clock initiale in Khz = %05u \r\n",clk);    // _doprntf utilise 8900 bytes !
    CPrint("  Clock initiale in MHz = ");
    WordToStr( clk,CRam1);
    Print(CRam1);
    CRLF1();
    
    GIE_bit=1;
    CPrint(" Test Timer1 80x25ms soit 2sec \r\n");
    // activer sample time du terminal!
    Init_Timer1();
    U1TXB='D' ;CRLF1();
    Arme_Timer1(80);
    while(Flag_Timer1==0);
    U1TXB='F' ;CRLF1();
     CRLF1();
     
   CPrint(" Test compteur 24 bits SMT1 sur FOSC=64MHz en mode chronometre\r\n");
   CPrint(" Resolution compteur +- 16 nanoSec (dure maxima mesurable = 262mS)\r\n");
   CPrint(" Init  SMT1 \r\n");
   Init_SMT1();

    ST=&SMT1_Measure; // pointeur Byte sur debut entier long 32 bits
    CPrint(" Start SMT1 for test delay 10mS\r\n");
    SMT1_Measure=0;
    SMT1STAT.RST=1;
    SMT1CON1.SMT1GO=1;
    Delay_ms(10);
    SMT1CON1.SMT1GO=0;
    txt=&TEXTE[0];
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
    CPrint( " Stop.\r\n SMT1 tics  -> ");
    if (SMT1_Measure>3)  SMT1_Measure=SMT1_Measure-4;
    LongWordToStr(SMT1_Measure,CRam1);  Print(CRam1);
      if (SMT1_Measure>63)
     {
      SMT1_Measure=SMT1_Measure>>6 ;
      sprintf(txt," , et (via sprintf) -> %lu uS ",SMT1_Measure);
      }
      else
      {
      F1=(float) SMT1_Measure* 0.015625;
      sprintf(txt," ,et (via sprintf) -> %3.3f uS ",F1);
      }
    Print(txt);
    CRLF1();
   
   

    CPrint(" Test SMT1 sur 1mS  \r\n");
     // MODE de fonctionnement
     // modes  page 396   Windowed measure
     //   0000=Timer   0100=windowed measure  1000=counter
     SMT1CON1.B3=0;
     SMT1CON1.B2=0;
     SMT1CON1.B1=0;
     SMT1CON1.B0=0;
     SMT1CON1.SMT1REPEAT=0;
   
   SMT1_Measure=0;
   SMT1STAT.RST=1;
   LED_Rouge=ON;
   LED_Verte= SMT1STAT.B0 ;
   SMT1CON1.SMT1GO=1;    //        MARCHE
   Delay_ms(1);
   SMT1CON1.SMT1GO=0;  //          ARRET
   LED_Verte= SMT1STAT.B0 ;  //
   LED_Rouge=OFF;
   *(ST)= SMT1TMRL;
   *(ST+1)= SMT1TMRH;
   *(ST+2)= SMT1TMRU;
   *(ST+3)=0  ; //  *(ST+3)=2 ; => 33554432
   CPrint( " Stop.\r\n SMT1 tics  -> ");
    if (SMT1_Measure>3)  SMT1_Measure=SMT1_Measure-4;
   LongWordToStr(SMT1_Measure,CRam1);   Print(CRam1);
    if (SMT1_Measure>63)
     {
      SMT1_Measure=SMT1_Measure>>6 ;
      sprintf(txt," , et (via sprintf) -> %lu uS ",SMT1_Measure);
      }
      else
      {
      F1=(float) SMT1_Measure* 0.015625;
      sprintf(txt," ,et (via sprintf) -> %3.3f uS ",F1);
      }
    Print(txt);
    CRLF1();
   

     CPrint(" Test SMT1 sur 8 NOP  \r\n");
     // MODE de fonctionnement
     // modes  page 396   Windowed measure
     //   0000=Timer   0100=windowed measure  1000=counter
     SMT1CON1.B3=0;
     SMT1CON1.B2=0;
     SMT1CON1.B1=0;
     SMT1CON1.B0=0;
     SMT1CON1.SMT1REPEAT=0;

   SMT1_Measure=0;
   SMT1STAT.RST=1;
   LED_Rouge=ON;
   LED_Verte= SMT1STAT.B0 ;
   SMT1CON1.SMT1GO=1;    //        MARCHE
     _asm NOP
      _asm NOP
       _asm NOP
        _asm NOP
         _asm NOP
          _asm NOP
           _asm NOP
             _asm NOP
   SMT1CON1.SMT1GO=0;  //          ARRET
   LED_Verte= SMT1STAT.B0 ;  //
   LED_Rouge=OFF;
   *(ST)= SMT1TMRL;
   *(ST+1)= SMT1TMRH;
   *(ST+2)= SMT1TMRU;
   *(ST+3)=0  ; //  *(ST+3)=2 ; => 33554432
   CPrint( " Stop.\r\n SMT1 tics  -> ");
   if (SMT1_Measure>3)  SMT1_Measure=SMT1_Measure-4;   // 4 tics residuels!
   LongWordToStr(SMT1_Measure,CRam1);   Print(CRam1);
     if (SMT1_Measure>63)
     {
      SMT1_Measure=SMT1_Measure>>6 ;    // division par 64 => multiplication par 0.015625
      sprintf(txt," , et (via sprintf) -> %lu uS ",SMT1_Measure);
      }
      else
      {
      F1=(float) SMT1_Measure* 0.015625;
      sprintf(txt," ,et (via sprintf) -> %3.3f uS ",F1);
      }
    Print(txt);
    CRLF1();
     CPrint( "Fin de test ...!\r\n ");
    Delay_ms(5000);
     CPrint( " Reboot !\r\n ");
     _asm reset;
  }


    /*
"25/08/2022 15:24:43", Reboot !


"15:24:45", Presentation :
"15:24:46", Directory :C:\_MikroC\_MesProjets_MikroC\_18F27K42_Tests_SMT1_chronometre_2022_08
"15:24:46", MikroC pro 7.60

"15:24:46", Projet :18F27K42_Tests_SMT1_chronometre_2022_08.mcppi
"15:24:46", Test PIC18F27K42 IVT et compteur 24 bits SMT1 en chronometre
"15:24:46", Config bit :  P18F27K42_Fosc_Interne_IVT_interrupts_16x4_PLL_64MHz.cfgsch  FOSC:64.0 MHz
"15:24:46", Source : PIC18F27K42_test_SMT1_Chronometre_UART_IVT__2022_0825.c
"15:24:46",  Clock initiale in MHz =    64
"15:24:46", Test Timer1 80x25ms soit 2sec
"15:24:46",D
"15:24:48",F

"15:24:48", Test compteur 24 bits SMT1 sur FOSC=64MHz en mode chronometre
"15:24:48", Resolution compteur +- 16 nanoSec (dure maxima mesurable = 262mS)
"15:24:48", Init  SMT1
"15:24:48", Test SMT compteur 24 bits (rsum des registres en page 364)
"15:24:48", Start SMT1 for test delay 10mS
"15:24:48", Stop.
"15:24:48", SMT1 tics  ->     640000 , et (via sprintf) -> 10000 uS
"15:24:48", Test SMT1 sur 1mS
"15:24:48", Stop.
"15:24:48", SMT1 tics  ->      64000 , et (via sprintf) -> 1000 uS
"15:24:48", Test SMT1 sur 8 NOP
"15:24:48", Stop.
"15:24:48", SMT1 tics  ->         32 ,et (via sprintf) -> 0.500 uS
"15:24:48",Fin de test ...!
"15:24:48",  Reboot !

 */